program PB_test;
uses
  windows, messages, dpslib;

{$INCLUDE ATOI.PAS}
{$INCLUDE CompilerSwitches.PAS}
{$R main.RES}
const
  stdaddr = 21;
  stdbaud = 6;
  stdident = $9901;
  stdinpoutp = 16;

  IDI_ICON1 = 1;
  IDD_DIALOG1 = 101;
  IDC_LIST1 = 1000;
  IDC_BUTTON1 = 1001;
  IDC_BUTTON2 = 1002;
  IDC_BUTTON3 = 1003;
  IDC_BUTTON4 = 1004;
  IDC_BUTTON5 = 1005;
  IDC_BUTTON6 = 1006;
  IDC_EDIT1 = 1007;
  IDC_EDIT2 = 1008;
  IDC_EDIT4 = 1014;
  IDC_COMBO1 = 1009;
  IDC_COMBO2 = 1010;
  IDC_EDIT5 = 1015;
  IDC_CHECK1 = 1016;
  IDC_CHECK2 = 1017;
  IDC_EDIT6 = 1020;

  progname = 'PB-test v.1.23 - (c) by -=Assarbad=-';
  oldproc = 'oldwndproc';
var
  globerr: DP_ERROR;
  globhandle: DPR_DWORD = 0;
  init_data: DPS_INIT_DATA;
  max_data_len: DPS_MAX_DATA;
  buff: array[0..$500] of DPR_STRING;
  sizebuff,
    hDlg,
    fix8,
    fix10,
    appicon: Cardinal;


  baudrates: array[0..11] of string =
  (
    '9,6 kBaud   - DPS_BD_9K6',
    '19,2 kBaud  - DPS_BD_19K2',
    '93,75 kBaud - DPS_BD_93K75',
    '187,5 kBaud - DPS_BD_187K5',
    '500 kBaud   - DPS_BD_500K',
    '1,5 MBaud   - DPS_BD_1M5',
    '3 MBaud     - DPS_BD_3M',
    '6 MBaud     - DPS_BD_6M',
    '12 MBaud    - DPS_BD_12M',
    '45,45 kBaud - DPS_BD_45K45',
    'DPS_BD_AUTO_DETECT',
    'DPS_BD_INVALID'
    );

function ischeckedbox(hwnd: HWND): boolean;
begin
  case sendmessage(hwnd, BM_GETCHECK, 0, 0) of
    BST_CHECKED: result := true;
  else result := false;
  end;
end;

procedure checkbox(hwnd: HWND; b: boolean = true);
begin
  case b of
    TRUE: sendmessage(hwnd, BM_SETCHECK, BST_CHECKED, 0);
    FALSE: sendmessage(hwnd, BM_SETCHECK, BST_UNCHECKED, 0);
  end;
end;

function frmt(mformat: string; args: array of POINTER; memsize: Cardinal = $FF): string;
var
  bla: pchar;
begin
  getmem(bla, memsize);
  wvsprintf(bla, pchar(mformat), pchar(@args));
  result := string(bla);
  freemem(bla);
end;

procedure AppendLB(hwnd: Cardinal; s: string);
begin
  SendMessage(hWnd, LB_ADDSTRING, 0, LongInt(Pchar(s)));
end;

procedure DebugOut(s: string; outerrcode: boolean = true);
var i: integer;
begin
  s := s + #0;
  AppendLB(GetDlgItem(hDlg, IDC_LIST1), string(CharUpper(@s[1])));
  case outerrcode of
    true:
      begin
        AppendLB(GetDlgItem(hDlg, IDC_LIST1), ' ERROR CLASS [' + frmt('0x%8.8X', [pointer(globerr.error_class)]) + '] -> ' + errorclassnames[globerr.error_class]);
        if globerr.error_class in [1, 2, 4] then
          AppendLB(GetDlgItem(hDlg, IDC_LIST1), ' ERROR CODE  [' + frmt('0x%8.8X', [pointer(globerr.error_code)]) + '] -> ' + errornames[globerr.error_class][globerr.error_code]);
        AppendLB(GetDlgItem(hDlg, IDC_LIST1), ' HANDLE                 -> ' + frmt('0x%8.8X', [pointer(globhandle)]));
      end;
  end;
  i := SendMessage(GetDlgItem(hDlg, IDC_LIST1), LB_GETCOUNT, 0, 0);
  if i <> LB_ERR then
    SendMessage(GetDlgItem(hDlg, IDC_LIST1), LB_SETTOPINDEX, i - 2, 0);
end;

procedure DPSsetinput;
begin
  ZeroMemory(@buff, sizeof(buff));
  GetDlgItemText(hDlg, IDC_EDIT2, @buff[0], sizebuff);
  DPS_set_input(globhandle, @buff[0], sizebuff, globerr);
  DebugOut('DPS_set_input');
end;

procedure DPSgetoutput;
var s: string;
  i: integer;
begin
  ZeroMemory(@buff, sizeof(buff));
  DPS_get_output(globhandle, @buff[0], sizebuff, globerr);
  s := '';
  for i := 0 to sizebuff - 1 do
    if i mod 4 = 0 then begin
      s := s + frmt('%8.8X ', [PDWORD(@buff[i])]);
    end;
  SetDlgItemText(hDlg, IDC_EDIT1, pchar(s));
  DebugOut('DPS_get_output');
end;

procedure DPSstart;
begin
  DPS_start(globhandle, globerr);
  DebugOut('DPS_start');
end;

procedure DPSstop;
begin
  DPS_stop(globhandle, globerr);
  DebugOut('DPS_stop');
end;

function baudrate(i: integer): DPR_WORD;
begin
  case i of
    0: result := DPS_BD_9K6;
    1: result := DPS_BD_19K2;
    2: result := DPS_BD_93K75;
    3: result := DPS_BD_187K5;
    4: result := DPS_BD_500K;
    5: result := DPS_BD_1M5;
    6: result := DPS_BD_3M;
    7: result := DPS_BD_6M;
    8: result := DPS_BD_12M;
    9: result := DPS_BD_45K45;
    10: result := DPS_BD_AUTO_DETECT;
  else result := DPS_BD_INVALID;
  end;
end;

procedure DPSopen;
var i, j, k, l: Longint;
  trans: Longbool;
  x: byte;
begin
  case globhandle of
    0:
      begin
        ZeroMemory(@globerr, sizeof(globerr));
        l := GetDlgItemInt(hdlg, IDC_EDIT6, trans, false);
        if not trans then l := stdinpoutp;
        sizebuff := 4 * l;
        x := cfgdata(l, ischeckedbox(getdlgitem(hdlg, IDC_CHECK1)), ischeckedbox(getdlgitem(hdlg, IDC_CHECK2)));
        init_data.cfg_data[0] := x;
        init_data.cfg_data[1] := x;
        init_data.cfg_data[2] := x;
        init_data.cfg_data[3] := x;
        init_data.cfg_data_len := 4;
        init_data.user_prm_data_len := 0;

        ZeroMemory(@max_data_len, sizeof(max_data_len));
        ZeroMemory(@buff, sizeof(buff));
        GetDlgItemText(hDlg, IDC_EDIT4, @buff[0], sizeof(buff) - 1);

        k := GetDlgItemInt(hdlg, IDC_EDIT5, trans, false);
        if not trans then k := stdident;
        i := SendMessage(GetDlgItem(hDlg, IDC_COMBO1), CB_GETCURSEL, 0, 0);
        j := SendMessage(GetDlgItem(hDlg, IDC_COMBO2), CB_GETCURSEL, 0, 0);
        DPS_open(pchar(@buff[0]), globhandle, DPS_SM_SIMPLE, j + 1, 0, k, 0, init_data, max_data_len, baudrate(i), globerr);
        DebugOut('DPS_open');
      end;
  else
    DebugOut('HANDLE in use. press close first!', false);
  end;
end;

procedure DPSclose;
begin
  DPS_close(globhandle, globerr);
  if globerr.error_class = 0 then begin
    SendMessage(GetDlgItem(hDlg, IDC_LIST1), LB_RESETCONTENT, 0, 0);
    ZeroMemory(@globerr, sizeof(globerr));
  end;
  DebugOut('DPS_close');
  if globerr.error_class = 0 then
    globhandle := 0;
end;

function AddCBItem(hwnd: Cardinal; s: string): integer;
begin
  result := sendmessage(hwnd, CB_ADDSTRING, 0, LongInt(pchar(s)));
end;

function editproc(hwnd: hwnd; umsg: Cardinal; wparam: wparam; lparam: lparam): LRESULT; stdcall;
var mybuf: array[0..MAX_PATH] of char;
  int: integer;
begin
  Result := 0;
  case umsg of
    WM_CHAR:
      begin
        result := CallWindowProc(pointer(getprop(hwnd, oldproc)), hwnd, umsg, wparam, lparam);
        ZeroMemory(@mybuf, sizeof(mybuf));
        sendmessage(hwnd, WM_GETTEXT, sizeof(mybuf), Longint(@mybuf));
        int := _strtoint(string(pchar(@mybuf[0])));
        case int > 16 of
          true: sendmessage(hwnd, WM_SETTEXT, 0, Longint(Pchar('16')));
        end;
      end;
  else result := CallWindowProc(pointer(getprop(hwnd, oldproc)), hwnd, umsg, wparam, lparam);
  end;
end;

function editproc2(hwnd: hwnd; umsg: Cardinal; wparam: wparam; lparam: lparam): LRESULT; stdcall;
var mybuf: array[0..MAX_PATH] of char;
  int: Longint;
begin
  Result := 0;
  case umsg of
    WM_CHAR:
      begin
        result := CallWindowProc(pointer(getprop(hwnd, oldproc)), hwnd, umsg, wparam, lparam);
        ZeroMemory(@mybuf, sizeof(mybuf));
        sendmessage(hwnd, WM_GETTEXT, sizeof(mybuf), Longint(@mybuf));
        int := _strtoint(string(pchar(@mybuf[0])));
        case int > $FFFF of
          true: sendmessage(hwnd, WM_SETTEXT, 0, Longint(Pchar('65535')));
        end;
      end;
  else result := CallWindowProc(pointer(getprop(hwnd, oldproc)), hwnd, umsg, wparam, lparam);
  end;
end;

function dlgfunc(hwnd: hwnd; umsg: Cardinal; wparam: wparam; lparam: lparam): bool; stdcall;
var i: Longint;
begin
  Result := false;
  case umsg of
    WM_INITDIALOG:
      begin
        hDlg := hwnd;
        fix8 := CreateFont(-MulDiv(8, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH or FF_MODERN, 'Courier New');
        fix10 := CreateFont(-MulDiv(10, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH or FF_MODERN, 'Courier New');
        sendmessage(Getdlgitem(hwnd, IDC_EDIT1), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT2), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT4), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_LIST1), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_COMBO1), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_COMBO2), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON1), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON2), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON3), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON4), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON5), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_BUTTON6), WM_SETFONT, fix8, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT5), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT6), WM_SETFONT, fix10, LongInt(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_EDIT6), EM_SETLIMITTEXT, 4, 0);
        sendmessage(hwnd, WM_SETTEXT, 0, LongInt(pchar(progname)));
        setprop(getdlgitem(hwnd, IDC_EDIT5), oldproc, setwindowlong(getdlgitem(hwnd, IDC_EDIT5), GWL_WNDPROC, integer(@editproc2)));
        setprop(getdlgitem(hwnd, IDC_EDIT6), oldproc, setwindowlong(getdlgitem(hwnd, IDC_EDIT6), GWL_WNDPROC, integer(@editproc)));

        setdlgitemint(hwnd, IDC_EDIT6, stdinpoutp, false);
        setdlgitemint(hwnd, IDC_EDIT5, stdident, false);
        checkbox(getdlgitem(hwnd, IDC_CHECK1));
        checkbox(getdlgitem(hwnd, IDC_CHECK2));
        for i := 0 to length(Baudrates) - 1 do
          AddCBItem(GetDlgItem(hwnd, IDC_COMBO1), Baudrates[i]);
        for i := 1 to 126 do
          AddCBItem(GetDlgItem(hwnd, IDC_COMBO2), _inttostr(i));
        SendDlgItemMessage(hwnd, IDC_COMBO1, CB_SETCURSEL, stdbaud - 1, 0);
        SendDlgItemMessage(hwnd, IDC_COMBO2, CB_SETCURSEL, stdaddr - 1, 0);
        sendmessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
        sendmessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        SetDlgItemText(hwnd, IDC_EDIT4, 'DPSONLINE');
        DebugOut('Welcome to PB-test', false);
        sendmessage(GetDlgItem(hwnd, IDC_LIST1), LB_SETHORIZONTALEXTENT, 1400, 0);
      end;
    WM_CTLCOLORSTATIC:
      begin
        SetTextColor(wParam, RGB($33, $55, $55));
        SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
        result := BOOL(GetSysColorBrush(COLOR_3DFACE));
      end;
    WM_CTLCOLORLISTBOX:
      begin
        SetTextColor(wParam, RGB($55, $22, $22));
        SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
        result := BOOL(GetSysColorBrush(COLOR_3DFACE));
      end;
    WM_CTLCOLORDLG:
      result := BOOL(GetSysColorBrush(COLOR_3DFACE));
    WM_CTLCOLOREDIT:
      case GetDlgCtrlID(lParam) of
        IDC_EDIT1,
          IDC_EDIT2:
          begin
            SetTextColor(wParam, RGB(0, $44, $22));
            SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_EDIT4,
          IDC_EDIT5,
          IDC_EDIT6:
          begin
            SetTextColor(wParam, RGB($44, 0, 0));
            SetBkColor(wParam, GetSysColor(COLOR_3DFACE));
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
      else result := false;
      end;
    WM_CLOSE:
      EndDialog(hwnd, 0);
    WM_COMMAND:
      case HiWord(WParam) of
        BN_CLICKED:
          case LOWORD(wParam) of
            IDC_BUTTON1,
              IDC_BUTTON2,
              IDC_BUTTON3,
              IDC_BUTTON4,
              IDC_BUTTON5,
              IDC_BUTTON6:
              begin
                EnableWindow(GetDlgItem(hwnd, LOWORD(wParam)), false);
                case LOWORD(wParam) of
                  IDC_BUTTON1: DPSopen;
                  IDC_BUTTON2: DPSclose;
                  IDC_BUTTON3: DPSstart;
                  IDC_BUTTON4: DPSstop;
                  IDC_BUTTON5: DPSgetoutput;
                  IDC_BUTTON6: DPSsetinput;
                end;
                EnableWindow(GetDlgItem(hwnd, LOWORD(wParam)), true);
              end;
          end;
      end;
  else result := false;
  end;
end;


begin
  appicon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
  DialogBoxParam(HInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @dlgfunc, 0)
end.

